// Autor: Johnnie
// Agradecimentos ao Caio Sant'Ana por ajudar com as variaveis, floats, gosubs, e sistema de travar/destravar o veiculo.
SCRIPT_START
{
    LVAR_INT player car lock_state boot_state window_state engine headlights

    LVAR_INT lockKey trunkKey engineKey winKey lightKey

    LVAR_FLOAT x y z

    GET_PLAYER_CHAR 0 player

    lock_state = 0

    boot_state = 0

    window_state = 0

    engine = 0

    headlights = 0

    IF NOT READ_INT_FROM_INI_FILE "cleo/ExCarFuncs.ini" "Commands" "cLocking" (lockKey)
        lockKey = 76
    ENDIF

    IF NOT READ_INT_FROM_INI_FILE "cleo/ExCarFuncs.ini" "Commands" "cVehTrunk" (trunkKey)
        trunkKey = 49
    ENDIF

    IF NOT READ_INT_FROM_INI_FILE "cleo/ExCarFuncs.ini" "Commands" "cVehEngine" (engineKey)
        engineKey = 84
    ENDIF

    IF NOT READ_INT_FROM_INI_FILE "cleo/ExCarFuncs.ini" "Commands" "cVehWindows" (winKey)
        winKey = 50
    ENDIF

    IF NOT READ_INT_FROM_INI_FILE "cleo/ExCarFuncs.ini" "Commands" "cVehLights" (lightKey)
        lightKey = 74
    ENDIF

label:

WHILE TRUE
    WAIT 0

    STORE_CAR_CHAR_IS_IN_NO_SAVE player car

    GET_OFFSET_FROM_CHAR_IN_WORLD_COORDS player 0.0 1.0 0.0 x y z // Armazenar um deslocamento de ponto da posicao.

    // Travar e destravar dentro do carro.

    IF IS_CHAR_IN_CAR player car
        AND IS_KEY_PRESSED lockKey
        AND lock_state = 0
        PRINT_HELP_STRING "DOOR LOCKED" 
        LOCK_CAR_DOORS car 4
        lock_state = 1
        WHILE IS_KEY_PRESSED lockKey
            WAIT 0
        ENDWHILE
    ENDIF

    IF IS_CHAR_IN_CAR player car
        AND IS_KEY_PRESSED lockKey
        AND lock_state = 1
        PRINT_HELP_STRING "DOOR UNLOCKED" 
        LOCK_CAR_DOORS car 1
        lock_state = 0
        WHILE IS_KEY_PRESSED lockKey
            WAIT 0
        ENDWHILE
    ENDIF

        // travar e destravar fora do veiculo em uma distancia.

    IF GET_RANDOM_CAR_IN_SPHERE_NO_SAVE_RECURSIVE x y z 8.0 FALSE TRUE (car) // Se o carro estiver perto do CJ
    AND NOT IS_CHAR_IN_CAR player car
        AND IS_KEY_PRESSED lockKey
        AND lock_state = 1
            PRINT_HELP_STRING "DOOR UNLOCKED" 
            LOCK_CAR_DOORS car 1 // Destranca as portas do nosso veiculo.
            SWITCH_CAR_SIREN car 0
            // Sistema  de luzes.
            WAIT 100
            FORCE_CAR_LIGHTS car 2
            WAIT 50
            FORCE_CAR_LIGHTS car 1
            WAIT 50
            FORCE_CAR_LIGHTS car 2
            WAIT 100
            FORCE_CAR_LIGHTS car 2
            WAIT 50
            FORCE_CAR_LIGHTS car 0
            lock_state = 0 // Sistema de travamento desativado.
            WHILE IS_KEY_PRESSED lockKey
                WAIT 0
            ENDWHILE
        ENDIF

    IF GET_RANDOM_CAR_IN_SPHERE_NO_SAVE_RECURSIVE x y z 8.0 FALSE TRUE (car) // Se o carro estiver perto do CJ 
    AND NOT IS_CHAR_IN_CAR player car
        AND IS_KEY_PRESSED lockKey
        AND lock_state = 0
            PRINT_HELP_STRING "DOOR LOCKED" 
            SWITCH_CAR_SIREN car 1
            LOCK_CAR_DOORS car 4  // Tranca as portas do nosso veiculo.
            // Sistema de Luzes.
            WAIT 100
            FORCE_CAR_LIGHTS car 2
            WAIT 50
            FORCE_CAR_LIGHTS car 1  
            WAIT 50
            FORCE_CAR_LIGHTS car 2
            WAIT 100
            FORCE_CAR_LIGHTS car 2
            WAIT 50
            FORCE_CAR_LIGHTS car 0
            lock_state = 1 // Sistema de travamento ativado
            WHILE IS_KEY_PRESSED lockKey
                WAIT 0
            ENDWHILE
        ENDIF

        IF NOT GET_RANDOM_CAR_IN_SPHERE_NO_SAVE_RECURSIVE x y z 8.0 FALSE TRUE (car) // Se o carro estiver perto do CJ 
            MARK_CAR_AS_NO_LONGER_NEEDED car
            MARK_MODEL_AS_NO_LONGER_NEEDED car
                lock_state = 0 
                boot_state = 0
                window_state = 0
                engine = 0
                headlights = 0
        ENDIF        

// Abrir/Fechar porta-malas por dentro do veiculo.

    IF IS_CHAR_IN_CAR player car
        AND IS_KEY_PRESSED trunkKey
        AND boot_state = 0
            WHILE IS_KEY_PRESSED trunkKey
                WAIT 0
            ENDWHILE
            GOSUB open-close_boot
        ENDIF

    IF IS_CHAR_IN_CAR player car
        AND IS_KEY_PRESSED trunkKey
        AND boot_state = 1
            WHILE IS_KEY_PRESSED trunkKey
                WAIT 0
            ENDWHILE
            GOSUB open-close_boot
        ENDIF

// Ligar/Desligar Motor

    IF IS_CHAR_IN_CAR player car
    AND IS_KEY_PRESSED engineKey
    AND engine = 0
        SET_CAR_ENGINE_ON car 1
        WHILE IS_KEY_PRESSED engineKey
            WAIT 0
        ENDWHILE
        engine = 1
    ENDIF

    IF IS_CHAR_IN_CAR player car
    AND IS_KEY_PRESSED engineKey
    AND engine = 1
        SET_CAR_ENGINE_ON car 0
        WHILE IS_KEY_PRESSED engineKey
            WAIT 0
        ENDWHILE
        engine = 0
    ENDIF
    
//Abrir/Fechar vidro do motorista.
    
    IF IS_CHAR_IN_CAR player car
    AND IS_KEY_PRESSED winKey
    AND window_state = 0
        SET_CAR_DOOR_WINDOW_STATE car 10 0
        WHILE IS_KEY_PRESSED winKey
            WAIT 0
        ENDWHILE
        window_state = 1
        ENDIF

    IF IS_CHAR_IN_CAR player car
    AND IS_KEY_PRESSED winKey
    AND window_state = 1
        SET_CAR_DOOR_WINDOW_STATE car 10 1
        WHILE IS_KEY_PRESSED winKey
            WAIT 0
        ENDWHILE
        window_state = 0
    ENDIF

//Ligar/Desligar/Habilitar Modo Automático dos Faróis

    IF IS_CHAR_IN_CAR player car
    AND IS_KEY_PRESSED lightKey
    AND headlights = 0
        FORCE_CAR_LIGHTS car 2
        WHILE IS_KEY_PRESSED lightKey
            WAIT 0
        ENDWHILE
        headlights = 1
    ENDIF

    IF IS_CHAR_IN_CAR player car
    AND IS_KEY_PRESSED lightKey
    AND headlights = 1
        FORCE_CAR_LIGHTS car 1
        WHILE IS_KEY_PRESSED lightKey
            WAIT 0
        ENDWHILE
        headlights = 3
    ENDIF

    IF IS_CHAR_IN_CAR player car
    AND IS_KEY_PRESSED lightKey
    AND headlights = 3
        FORCE_CAR_LIGHTS car 0
        WHILE IS_KEY_PRESSED lightKey
            WAIT 0
        ENDWHILE
        headlights = 0
    ENDIF

ENDWHILE

open-close_boot:

IF boot_state = 0

// Simulacao de Porta-malas abrindo

OPEN_CAR_DOOR_A_BIT car 1 0.05
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.1
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.15
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.2
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.25
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.3
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.35
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.4
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.45
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.5
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.55
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.6
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.65
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.7
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.75
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.8
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.85
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.9
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.95
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  1.0

boot_state = 1

ELSE

IF boot_state = 1

// Simulacao de Porta-malas fechando

OPEN_CAR_DOOR_A_BIT car 1  0.95
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.9
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.85
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.8
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.75
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.7
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.65
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.6
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.55
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.5
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.45
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.4
WAIT 10 
OPEN_CAR_DOOR_A_BIT car 1  0.35
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.3
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.25
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.2
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.15
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.1
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1  0.05
WAIT 10
OPEN_CAR_DOOR_A_BIT car 1 0.0

boot_state = 0

ENDIF

ENDIF

RETURN

}
SCRIPT_END